Index: squid/src/client_side.c
diff -u squid/src/client_side.c:1.1.1.2 squid/src/client_side.c:1.1.1.2.10.1
--- squid/src/client_side.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/client_side.c	Fri Nov 10 10:44:52 2000
@@ -58,6 +58,9 @@
 #endif
 #endif
 
+#ifdef	HPL_REPL
+#include "heap.h"
+#endif	/* HPL_REPL */
 
 
 #if LINGERING_CLOSE
@@ -284,6 +287,9 @@
 	    new_request->body_sz = old_request->body_sz;
 	}
 	requestUnlink(old_request);
+	if (!*new_request->host)
+	    xstrncpy(new_request->host, internalHostname(),
+		SQUIDHOSTNAMELEN);
 	http->request = requestLink(new_request);
     }
     clientInterpretRequestHeaders(http);
@@ -298,7 +304,7 @@
     char *url = http->uri;
     StoreEntry *entry = NULL;
     debug(33, 3) ("clientProcessExpired: '%s'\n", http->uri);
-    assert(http->entry->lastmod >= 0);
+    assert(http->entry->Slastmod >= 0);
     /*
      * check if we are allowed to contact other servers
      * @?@: Instead of a 504 (Gateway Timeout) reply, we may want to return 
@@ -326,15 +332,26 @@
     /* delay_id is already set on original store client */
     delaySetStoreClient(entry, http, delayClient(http->request));
 #endif
-    entry->lastmod = http->old_entry->lastmod;
-    debug(33, 5) ("clientProcessExpired: lastmod %d\n", (int) entry->lastmod);
-    entry->refcount++;		/* EXPIRED CASE */
+    entry->Slastmod = http->old_entry->Slastmod;
+    debug(33, 5) ("clientProcessExpired: lastmod %d\n", (int) entry->Slastmod);
+    entry->Srefcount++;		/* EXPIRED CASE */
+#ifdef	HPL_REPL
+    /* 
+     * Update the position of this object in the store heap and memory
+     * heap.  The cache replacement policy uses refcount to determie the
+     * priority value of the object.
+     */
+    if (entry->n.ode.id >= 0)
+      heap_update(Store_Heap(entry), &entry->n.ode);
+    if (entry->mem_obj->n.ode.id >= 0)
+      heap_update(inmem_heap, &entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
     http->entry = entry;
     http->out.offset = 0;
     fwdStart(http->conn->fd, http->entry, http->request,
 	http->conn->peer.sin_addr, http->conn->me.sin_addr);
     /* Register with storage manager to receive updates when data comes in. */
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED))
 	debug(33, 0) ("clientProcessExpired: found ENTRY_ABORTED object\n");
     storeClientCopy(entry,
 	http->out.offset,
@@ -399,13 +416,13 @@
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     }
-    if (size < 0 && !EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (size < 0 && !EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
     }
     mem = entry->mem_obj;
     status = mem->reply->sline.status;
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	debug(33, 3) ("clientHandleIMSReply: ABORTED '%s'\n", url);
 	/* We have an existing entry, but failed to validate it */
 	/* Its okay to send the old one anyway */
@@ -413,7 +430,14 @@
 	storeUnregister(entry, http);
 	storeUnlockObject(entry);
 	entry = http->entry = http->old_entry;
-	entry->refcount++;
+	entry->Srefcount++;
+#ifdef	HPL_REPL
+	/* Update the position of this object in the store and memory heaps. */
+	if (entry->n.ode.id >= 0)
+	  heap_update(Store_Heap(entry), &entry->n.ode);
+	if (entry->mem_obj->n.ode.id >= 0)
+	  heap_update(inmem_heap, &entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
     } else if (STORE_PENDING == entry->store_status && 0 == status) {
 	debug(33, 3) ("clientHandleIMSReply: Incomplete headers for '%s'\n", url);
 	if (size >= CLIENT_SOCK_SZ) {
@@ -424,7 +448,14 @@
 	    storeUnregister(entry, http);
 	    storeUnlockObject(entry);
 	    entry = http->entry = http->old_entry;
-	    entry->refcount++;
+	    entry->Srefcount++;
+#ifdef	HPL_REPL
+	    /* Update the position of this object in the store and memory heaps. */
+	    if (entry->n.ode.id >= 0)
+	      heap_update(Store_Heap(entry), &entry->n.ode);
+	    if (entry->mem_obj->n.ode.id >= 0)
+	      heap_update(inmem_heap, &entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
 	    /* continue */
 	} else {
 	    storeClientCopy(entry,
@@ -455,7 +486,7 @@
 	storeUnregister(entry, http);
 	storeUnlockObject(entry);
 	entry = http->entry = oldentry;
-	entry->timestamp = squid_curtime;
+	entry->Stimestamp = squid_curtime;
 	if (unlink_request) {
 	    requestUnlink(entry->mem_obj->request);
 	    entry->mem_obj->request = NULL;
@@ -464,8 +495,15 @@
 	/* the client can handle this reply, whatever it is */
 	http->log_type = LOG_TCP_REFRESH_MISS;
 	if (HTTP_NOT_MODIFIED == mem->reply->sline.status) {
-	    http->old_entry->timestamp = squid_curtime;
-	    http->old_entry->refcount++;
+	    http->old_entry->Stimestamp = squid_curtime;
+	    http->old_entry->Srefcount++;
+#ifdef	HPL_REPL
+	    /* Update the position of this object in the store and memory heaps. */
+	    if (http->old_entry->n.ode.id >= 0)
+	      heap_update(Store_Heap(http->old_entry), &http->old_entry->n.ode);
+	    if (http->old_entry->mem_obj->n.ode.id >= 0)
+	      heap_update(inmem_heap, &http->old_entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
 	    http->log_type = LOG_TCP_REFRESH_HIT;
 	}
 	storeUnregister(http->old_entry, http);
@@ -473,7 +511,7 @@
 	recopy = 0;
     }
     http->old_entry = NULL;	/* done with old_entry */
-    assert(!EBIT_TEST(entry->flags, ENTRY_ABORTED));
+    assert(!EBIT_TEST(entry->Sflag, ENTRY_ABORTED));
     if (recopy) {
 	storeClientCopy(entry,
 	    http->out.offset,
@@ -492,10 +530,10 @@
 {
     int object_length;
     MemObject *mem = entry->mem_obj;
-    time_t mod_time = entry->lastmod;
+    time_t mod_time = entry->Slastmod;
     debug(33, 3) ("modifiedSince: '%s'\n", storeUrl(entry));
     if (mod_time < 0)
-	mod_time = entry->timestamp;
+      mod_time = entry->Stimestamp;
     debug(33, 3) ("modifiedSince: mod_time = %d\n", (int) mod_time);
     if (mod_time < 0)
 	return 1;
@@ -560,9 +598,9 @@
 int
 checkNegativeHit(StoreEntry * e)
 {
-    if (!EBIT_TEST(e->flags, ENTRY_NEGCACHED))
+    if (!EBIT_TEST(e->Sflag, ENTRY_NEGCACHED))
 	return 0;
-    if (e->expires <= squid_curtime)
+    if (e->Sexpires <= squid_curtime)
 	return 0;
     if (e->store_status != STORE_OK)
 	return 0;
@@ -989,7 +1027,7 @@
     }
     /* got modification time? */
     if (spec.time >= 0) {
-	return http->entry->lastmod <= spec.time;
+	return http->entry->Slastmod <= spec.time;
     }
     assert(0);			/* should not happen */
     return 0;
@@ -1108,7 +1146,7 @@
      * Add Age header, not that our header must replace Age headers
      * from other caches if any
      */
-    if (http->entry->timestamp > 0) {
+    if (http->entry->Stimestamp > 0) {
 	httpHeaderDelById(hdr, HDR_AGE);
 	/*
 	 * we do not follow HTTP/1.1 precisely here becuase we rely
@@ -1117,8 +1155,8 @@
 	 * or if it is out of sync
 	 */
 	httpHeaderPutInt(hdr, HDR_AGE,
-	    http->entry->timestamp <= squid_curtime ?
-	    squid_curtime - http->entry->timestamp : 0);
+	    http->entry->Stimestamp <= squid_curtime ?
+	    squid_curtime - http->entry->Stimestamp : 0);
     }
     /* Append X-Cache */
     httpHeaderPutStrf(hdr, HDR_X_CACHE, "%s from %s",
@@ -1193,7 +1231,7 @@
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	debug(33, 3) ("clientCacheHit: request aborted\n");
 	return;
-    } else if (size < 0) {
+    } else if (size <= 0) {
 	/* swap in failure */
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	debug(33, 3) ("clientCacheHit: swapin failure for %s\n", http->uri);
@@ -1206,9 +1244,8 @@
 	clientProcessMiss(http);
 	return;
     }
-    assert(size > 0);
     mem = e->mem_obj;
-    assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
+    assert(!EBIT_TEST(e->Sflag, ENTRY_ABORTED));
     if (mem->reply->sline.status == 0) {
 	/*
 	 * we don't have full reply headers yet; either wait for more or
@@ -1261,7 +1298,7 @@
 	 * both have a stale version of the object.
 	 */
 	r->flags.need_validation = 1;
-	if (e->lastmod < 0) {
+	if (e->Slastmod < 0) {
 	    /*
 	     * Previous reply didn't have a Last-Modified header,
 	     * we cannot revalidate it.
@@ -1479,7 +1516,7 @@
 	debug(33, 1) ("clientSendMoreData: Deferring %s\n", storeUrl(entry));
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
 	return;
-    } else if (entry && EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    } else if (entry && EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	/* call clientWriteComplete so the client socket gets closed */
 	clientWriteComplete(fd, NULL, 0, COMM_OK, http);
 	memFree(buf, MEM_CLIENT_SOCK_BUF);
@@ -1591,12 +1628,12 @@
 	/*
 	 * Set the timeout BEFORE calling clientReadRequest().
 	 */
-	commSetTimeout(conn->fd, 15, requestTimeout, conn);
+	commSetTimeout(conn->fd, Config.Timeout.request, requestTimeout, conn);
 	clientReadRequest(conn->fd, conn);	/* Read next request */
 	/*
 	 * Note, the FD may be closed at this point.
 	 */
-    } else if ((entry = http->entry) == NULL) {
+    } else if (!(entry = http->entry)) {
 	/*
 	 * this request is in progress, maybe doing an ACL or a redirect,
 	 * execution will resume after the operation completes.
@@ -1604,9 +1641,8 @@
     } else {
 	debug(33, 1) ("clientKeepaliveNextRequest: FD %d Sending next\n",
 	    conn->fd);
-	assert(entry);
 	if (0 == storeClientCopyPending(entry, http)) {
-	    if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
+	    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED))
 		debug(33, 0) ("clientKeepaliveNextRequest: ENTRY_ABORTED\n");
 	    storeClientCopy(entry,
 		http->out.offset,
@@ -1640,7 +1676,7 @@
 	comm_close(fd);
     } else if (NULL == entry) {
 	comm_close(fd);		/* yuk */
-    } else if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    } else if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(fd);
     } else if ((done = clientCheckTransferDone(http)) != 0 || size == 0) {
 	debug(33, 5) ("clientWriteComplete: FD %d transfer is DONE\n", fd);
@@ -1663,7 +1699,7 @@
     } else {
 	/* More data will be coming from primary server; register with 
 	 * storage manager. */
-	if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
+	if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED))
 	    debug(33, 0) ("clientWriteComplete 2: ENTRY_ABORTED\n");
 	storeClientCopy(entry,
 	    http->out.offset,
@@ -1729,7 +1765,7 @@
 	http->entry = NULL;
 	return LOG_TCP_MISS;
     }
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
+    if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL)) {
 	/* Special entries are always hits, no matter what the client says */
 	debug(33, 3) ("clientProcessRequest2: ENTRY_SPECIAL HIT\n");
 	http->entry = e;
@@ -1824,7 +1860,14 @@
 #if DELAY_POOLS
 	delaySetStoreClient(http->entry, http, delayClient(r));
 #endif
-	http->entry->refcount++;
+	http->entry->Srefcount++;
+#ifdef	HPL_REPL
+	/* Update the position of this object in the store and memory heaps. */
+	if (http->entry->n.ode.id >= 0)
+	  heap_update(Store_Heap(http->entry), &http->entry->n.ode);
+	if (http->entry->mem_obj->n.ode.id >= 0)
+	  heap_update(inmem_heap, &http->entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
 	storeClientCopy(http->entry,
 	    http->out.offset,
 	    http->out.offset,
@@ -1855,7 +1898,7 @@
      * or IMS request.
      */
     if (http->entry) {
-	if (EBIT_TEST(http->entry->flags, ENTRY_SPECIAL))
+	if (EBIT_TEST(http->entry->Sflag, ENTRY_SPECIAL))
 	    debug(33, 0) ("clientProcessMiss: miss on a special object (%s).\n", url);
 	storeUnregister(http->entry, http);
 	storeUnlockObject(http->entry);
@@ -1879,7 +1922,14 @@
     }
     assert(http->out.offset == 0);
     http->entry = clientCreateStoreEntry(http, r->method, r->flags);
-    http->entry->refcount++;
+    http->entry->Srefcount++;
+#ifdef	HPL_REPL
+    /* Update the position of this object in the store and memory heaps. */
+    if (http->entry->n.ode.id >= 0)
+      heap_update(Store_Heap(http->entry), &http->entry->n.ode);
+    if (http->entry->mem_obj->n.ode.id >= 0)
+      heap_update(inmem_heap, &http->entry->mem_obj->n.ode);
+#endif	/* HPL_REPL */
     if (http->redirect.status) {
 	HttpReply *rep = httpReplyCreate();
 	storeReleaseRequest(http->entry);
@@ -2087,14 +2137,16 @@
 	    if (natfd < 0) {
 		debug(50, 1) ("parseHttpRequest: NAT open failed: %s\n",
 		    xstrerror());
-		return parseHttpRequestAbort(conn, "error:nat-open-failed");
+		http = parseHttpRequestAbort(conn, "error:nat-open-failed");
+		goto ret;
 	    }
 	    if (ioctl(natfd, SIOCGNATL, &natLookup) < 0) {
 		if (errno != ESRCH) {
 		    debug(50, 1) ("parseHttpRequest: NAT lookup failed: ioctl(SIOCGNATL)\n");
 		    close(natfd);
 		    natfd = -1;
-		    return parseHttpRequestAbort(conn, "error:nat-lookup-failed");
+		    http = parseHttpRequestAbort(conn, "error:nat-lookup-failed");
+		    goto ret;
 		} else
 		    snprintf(http->uri, url_sz, "http://%s:%d%s",
 			inet_ntoa(http->conn->me.sin_addr),
@@ -2133,8 +2185,9 @@
     debug(33, 5) ("parseHttpRequest: Complete request received\n");
     if (free_request)
 	safe_free(url);
-    xfree(inbuf);
     *status = 1;
+ret:
+    xfree(inbuf);
     return http;
 }
 
@@ -2249,7 +2302,7 @@
 	    conn->nrequests++;
 	    commSetTimeout(fd, Config.Timeout.lifetime, NULL, NULL);
 	    if (parser_return_code < 0) {
-		debug(33, 1) ("clientReadRequest: FD %d Invalid Request\n", fd);
+		debug(33, 1) ("clientReadRequest: FD %d Indecent proposal\n", fd);
 		err = errorCon(ERR_INVALID_REQ, HTTP_BAD_REQUEST);
 		err->request_hdrs = xstrdup(conn->in.buf);
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
Index: squid/src/comm.c
diff -u squid/src/comm.c:1.1.1.2 squid/src/comm.c:1.1.1.2.10.1
--- squid/src/comm.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/comm.c	Fri Nov 10 10:44:52 2000
@@ -597,7 +597,8 @@
      * michael@metal.iinet.net.au sez close() on
      * network sockets never blocks.
      */
-    close(fd);
+    if(close(fd))
+	debug(50, 0) ("comm_close: FD %d, %s\n", fd, xstrerror()), close(fd);
 #elif USE_ASYNC_IO
     if (doaioclose)
 	aioClose(fd);
Index: squid/src/defines.h
diff -u squid/src/defines.h:1.1.1.2 squid/src/defines.h:1.1.1.2.10.1
--- squid/src/defines.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/defines.h	Fri Nov 10 10:44:52 2000
@@ -87,7 +87,7 @@
 
 #define DNS_INBUF_SZ 4096
 
-#define FD_DESC_SZ		64
+#define FD_DESC_SZ		128
 
 #define FQDN_LOOKUP_IF_MISS	0x01
 #define FQDN_MAX_NAMES 5
@@ -208,6 +208,15 @@
 #define STORE_SWAP_BUF		DISK_PAGE_SIZE
 #define VM_WINDOW_SZ		DISK_PAGE_SIZE
 
+#define SWAP_DIR_SHIFT 24
+#define SWAP_FILE_MASK ((1<<SWAP_DIR_SHIFT)-1)
+	
+#define STORE_GRAN_ORDER	10
+#define STORE_GRAN_MAX		(1<<STORE_GRAN_ORDER)
+	
+#define Store_Heap(e)	\
+  (assert((e)->Sswap_file_number>=0),getswapdir((e)->Sswap_file_number)->heap)
+
 #define SKIP_BASIC_SZ ((size_t) 6)
 
 #define PINGER_PAYLOAD_SZ 8192
Index: squid/src/disk.c
diff -u squid/src/disk.c:1.1.1.2 squid/src/disk.c:1.1.1.2.10.1
--- squid/src/disk.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/disk.c	Fri Nov 10 10:44:52 2000
@@ -242,6 +242,12 @@
 #endif
     debug(6, 3) ("diskHandleWrite: FD %d\n", fd);
     assert(fdd->write_q != NULL);
+    if (fdd->write_q->len == fdd->write_q->buf_offset) {
+        debug(6, 0) ("diskHandleWrite: nothing to write FD %d offset %d\n",
+		fd, fdd->write_q->buf_offset);
+	diskHandleWriteComplete(fd, fdd->write_q, 0, 0);
+	return;
+    }
     assert(fdd->write_q->len > fdd->write_q->buf_offset);
 #if USE_ASYNC_IO
     aioWrite(fd,
@@ -296,7 +302,7 @@
     }
 #endif
     if (q == NULL)		/* Someone aborted then write completed */
-	return;
+	goto ret;
 
     if (len == -2 && errcode == -2) {	/* Write cancelled - cleanup */
 	do {
@@ -333,6 +339,8 @@
 	     * repeated write failures for the same FD because of
 	     * the queued data.
 	     */
+	    if (data == q)
+		data = 0;
 	    do {
 		fdd->write_q = q->next;
 		if (q->free_func)
@@ -354,6 +362,8 @@
 	    fdd->write_q = q->next;
 	    if (q->free_func)
 		(q->free_func) (q->buf);
+	    if (data == q)
+		data = 0;
 	    safe_free(q);
 	}
     }
@@ -390,11 +400,13 @@
 #ifdef OPTIMISTIC_IO
 	    F->flags.calling_io_handler = 0;
 #endif
-	    return;
+	    goto ret;
 	}
     }
     if (do_close)
 	file_close(fd);
+ret:
+    safe_free(data);
 }
 
 
Index: squid/src/enums.h
diff -u squid/src/enums.h:1.1.1.2 squid/src/enums.h:1.1.1.2.10.1
--- squid/src/enums.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/enums.h	Fri Nov 10 10:44:52 2000
@@ -535,6 +535,7 @@
     MEM_MEM_NODE,
     MEM_NETDBENTRY,
     MEM_NET_DB_NAME,
+    MEM_STORESWAPLOGDATA,
     MEM_NET_DB_PEER,
     MEM_PEER,
 #if USE_CACHE_DIGESTS
Index: squid/src/errorpage.c
diff -u squid/src/errorpage.c:1.1.1.2 squid/src/errorpage.c:1.1.1.2.10.1
--- squid/src/errorpage.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/errorpage.c	Fri Nov 10 10:44:52 2000
@@ -270,7 +270,7 @@
 	 * care about it, and we don't need to generate an
 	 * error message
 	 */
-	assert(EBIT_TEST(entry->flags, ENTRY_ABORTED));
+	assert(EBIT_TEST(entry->Sflag, ENTRY_ABORTED));
 	assert(mem->nclients == 0);
 	errorStateFree(err);
 	return;
@@ -298,7 +298,7 @@
     httpReplyDestroy(rep);
     mem->reply->sline.status = err->http_status;
     mem->reply->content_length = -1;
-    EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
+    EBIT_CLR(entry->Sflag, ENTRY_FWD_HDR_WAIT);
     storeBufferFlush(entry);
     storeComplete(entry);
     storeNegativeCache(entry);
@@ -599,6 +599,9 @@
     }
     if (*m)
 	memBufPrintf(&content, "%s", m);	/* copy tail */
-    assert(content.size == strlen(content.buf));
+    if (content.size != strlen(content.buf)) {
+	debug(4,0) ("errorBuildContent: %d, %d != %d\n", err->page_id,
+		content.size, strlen(content.buf));
+    }
     return content;
 }
Index: squid/src/filemap.c
diff -u squid/src/filemap.c:1.1.1.1 squid/src/filemap.c:1.1.1.1.12.1
--- squid/src/filemap.c:1.1.1.1	Tue Jan 25 19:21:47 2000
+++ squid/src/filemap.c	Fri Nov 10 10:44:52 2000
@@ -115,7 +115,8 @@
     for (count = 0; count < fm->nwords; count++) {
 	if (fm->file_map[word] != ALL_ONES)
 	    break;
-	word = (word + 1) % fm->nwords;
+	if (++word == fm->nwords)
+	    word = 0;
     }
     for (bit = 0; bit < BITS_IN_A_LONG; bit++) {
 	suggestion = ((unsigned long) word << LONG_BIT_SHIFT) | bit;
Index: squid/src/ftp.c
diff -u squid/src/ftp.c:1.1.1.2 squid/src/ftp.c:1.1.1.2.10.1
--- squid/src/ftp.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/ftp.c	Fri Nov 10 10:44:52 2000
@@ -306,6 +306,7 @@
 static void
 ftpLoginParser(const char *login, FtpStateData * ftpState, int escaped)
 {
+    static unsigned long counter;
     char *s = NULL;
     xstrncpy(ftpState->user, login, MAX_URL);
     if ((s = strchr(ftpState->user, ':'))) {
@@ -320,8 +321,10 @@
 	rfc1738_unescape(ftpState->user);
     if (ftpState->user[0] || ftpState->password[0])
 	return;
+
     xstrncpy(ftpState->user, "anonymous", MAX_URL);
-    xstrncpy(ftpState->password, Config.Ftp.anon_user, MAX_URL);
+    snprintf(ftpState->password, MAX_URL, "%lx.%s", counter++,
+	Config.Ftp.anon_user);
 }
 
 static void
@@ -863,7 +866,7 @@
     delay_id delay_id = delayMostBytesAllowed(mem);
 #endif
     assert(fd == ftpState->data.fd);
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(ftpState->ctrl.fd);
 	return;
     }
@@ -1216,6 +1219,10 @@
     int len;
     ErrorState *err;
     debug(9, 5) ("ftpReadControlReply\n");
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
+	comm_close(ftpState->ctrl.fd);
+	return;
+    }
     assert(ftpState->ctrl.offset < ftpState->ctrl.size);
     Counter.syscalls.sock.reads++;
     len = read(fd,
@@ -1297,7 +1304,8 @@
     for (W = &ftpState->ctrl.message; (*W)->next; W = &(*W)->next);
     safe_free(ftpState->ctrl.last_reply);
     ftpState->ctrl.last_reply = (*W)->key;
-    safe_free(*W);
+    memFree(*W, MEM_WORDLIST);
+    *W = 0;
     debug(9, 8) ("ftpReadControlReply: state=%d, code=%d\n", ftpState->state,
 	ftpState->ctrl.replycode);
     FTP_SM_FUNCS[ftpState->state] (ftpState);
@@ -1467,7 +1475,7 @@
     w = ftpState->pathcomps;
     ftpState->filepath = w->key;
     ftpState->pathcomps = w->next;
-    xfree(w);
+    memFree(w, MEM_WORDLIST);
     /* Check if we are to CWD or RETR */
     if (ftpState->pathcomps != NULL || ftpState->flags.isdir) {
 	ftpSendCwd(ftpState);
@@ -2371,7 +2379,7 @@
 	return;
     ftpState->flags.http_header_sent = 1;
     assert(e->mem_obj->inmem_hi == 0);
-    EBIT_CLR(e->flags, ENTRY_FWD_HDR_WAIT);
+    EBIT_CLR(e->Sflag, ENTRY_FWD_HDR_WAIT);
     filename = (t = strRChr(urlpath, '/')) ? t + 1 : strBuf(urlpath);
     if (ftpState->flags.isdir) {
 	mime_type = "text/html";
@@ -2422,7 +2430,7 @@
 	if (pe)
 	    storeRelease(pe);
 	storeRelease(e);
-    } else if (EBIT_TEST(e->flags, ENTRY_CACHABLE) && !ftpState->restarted_offset) {
+    } else if (EBIT_TEST(e->Sflag, ENTRY_CACHABLE) && !ftpState->restarted_offset) {
 	storeSetPublicKey(e);
     } else {
 	storeRelease(e);
Index: squid/src/globals.h
diff -u squid/src/globals.h:1.1.1.2 squid/src/globals.h:1.1.1.2.12.1
--- squid/src/globals.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/globals.h	Fri Nov 10 10:44:52 2000
@@ -30,6 +30,9 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
  *
  */
+#ifdef	HPL_REPL
+#include "heap.h"
+#endif	/* HPL_REPL */
 
 extern FILE *debug_log;		/* NULL */
 extern FILE *cache_useragent_log;	/* NULL */
@@ -53,8 +56,8 @@
 extern const char *const dash_str;	/* "-" */
 extern const char *const localhost;	/* "127.0.0.1" */
 extern const char *const null_string;	/* "" */
-extern const char *const version_string;	/* SQUID_VERSION */
-extern const char *const full_appname_string;	/* "Squid/" SQUID_VERSION */
+extern const char *const version_string;	/* SQUID_VERSION "BuGless" */
+extern const char *const full_appname_string;	/* "Squid/" SQUID_VERSION "BuGless"*/
 extern const char *const w_space;	/* " \t\n\r" */
 extern const char *fdTypeStr[];
 extern const char *hier_strings[];
@@ -124,7 +127,13 @@
 extern double current_dtime;
 extern int store_hash_buckets;	/* 0 */
 extern hash_table *store_table;	/* NULL */
+#ifdef	HPL_REPL
+extern heap_p store_heap;
+extern heap_p inmem_heap;
+extern key_func store_policy;
+#else	/* HPL_REPL */
 extern dlink_list store_list;
+#endif	/* HPL_REPL */
 extern dlink_list ClientActiveRequests;
 extern const String StringNull;	/* { 0, 0, NULL } */
 extern const MemBuf MemBufNull;	/* MemBufNULL */
Index: squid/src/gopher.c
diff -u squid/src/gopher.c:1.1.1.2 squid/src/gopher.c:1.1.1.2.10.1
--- squid/src/gopher.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/gopher.c	Fri Nov 10 10:44:52 2000
@@ -187,7 +187,7 @@
 	break;
     }
     memBufPrintf(&mb, "\r\n");
-    EBIT_CLR(gopherState->entry->flags, ENTRY_FWD_HDR_WAIT);
+    EBIT_CLR(gopherState->entry->Sflag, ENTRY_FWD_HDR_WAIT);
     storeAppend(gopherState->entry, mb.buf, mb.size);
     memBufClean(&mb);
 }
@@ -600,7 +600,7 @@
 #if DELAY_POOLS
     delay_id delay_id = delayMostBytesAllowed(entry->mem_obj);
 #endif
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(fd);
 	return;
     }
@@ -761,7 +761,7 @@
 	gopherSendComplete,
 	data,
 	memFree4K);
-    if (EBIT_TEST(gopherState->entry->flags, ENTRY_CACHABLE))
+    if (EBIT_TEST(gopherState->entry->Sflag, ENTRY_CACHABLE))
 	storeSetPublicKey(gopherState->entry);	/* Make it public */
 }
 
Index: squid/src/helper.c
diff -u squid/src/helper.c:1.1.1.2 squid/src/helper.c:1.1.1.2.10.1
--- squid/src/helper.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/helper.c	Fri Nov 10 10:44:52 2000
@@ -255,8 +255,11 @@
     debug(29, 5) ("helperHandleRead: %d bytes from %s #%d.\n",
 	len, hlp->id_name, srv->index + 1);
     if (len <= 0) {
-	if (len < 0)
+	if (len < 0) {
+	    if (errno == EAGAIN)
+		goto again;
 	    debug(50, 1) ("helperHandleRead: FD %d read: %s\n", fd, xstrerror());
+	}
 	comm_close(fd);
 	return;
     }
@@ -288,7 +291,7 @@
 	else
 	    helperKickQueue(hlp);
     } else {
-	commSetSelect(srv->rfd, COMM_SELECT_READ, helperHandleRead, srv, 0);
+again:	commSetSelect(srv->rfd, COMM_SELECT_READ, helperHandleRead, srv, 0);
     }
 }
 
@@ -308,7 +311,7 @@
     debug(14, 0) ("WARNING: All %s processes are busy.\n", hlp->id_name);
     debug(14, 0) ("WARNING: %d pending requests queued\n", hlp->stats.queue_size);
     if (hlp->stats.queue_size > hlp->n_running * 2)
-	fatalf("Too many queued %s requests", hlp->id_name);
+	debug(14, 0) ("Too many queued %s requests", hlp->id_name);
     debug(14, 1) ("Consider increasing the number of %s processes in your config file.\n", hlp->id_name);
 }
 
Index: squid/src/http.c
diff -u squid/src/http.c:1.1.1.2 squid/src/http.c:1.1.1.2.10.1
--- squid/src/http.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/http.c	Fri Nov 10 10:44:52 2000
@@ -106,7 +106,7 @@
 static void
 httpMakePublic(StoreEntry * entry)
 {
-    if (EBIT_TEST(entry->flags, ENTRY_CACHABLE))
+    if (EBIT_TEST(entry->Sflag, ENTRY_CACHABLE))
 	storeSetPublicKey(entry);
 }
 
@@ -124,7 +124,7 @@
 httpCacheNegatively(StoreEntry * entry)
 {
     storeNegativeCache(entry);
-    if (EBIT_TEST(entry->flags, ENTRY_CACHABLE))
+    if (EBIT_TEST(entry->Sflag, ENTRY_CACHABLE))
 	storeSetPublicKey(entry);
 }
 
@@ -133,7 +133,7 @@
 {
     int remove = 0;
     StoreEntry *pe;
-    if (!EBIT_TEST(e->flags, KEY_PRIVATE))
+    if (!EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	return;
     switch (status) {
     case HTTP_OK:
@@ -294,7 +294,7 @@
     int hdr_len;
     HttpReply *reply = entry->mem_obj->reply;
     debug(11, 3) ("httpProcessReplyHeader: key '%s'\n",
-	storeKeyText(entry->key));
+	storeKeyText(entry->Skey));
     if (httpState->reply_hdr == NULL)
 	httpState->reply_hdr = memAllocate(MEM_8K_BUF);
     if (httpState->reply_hdr_state == 0) {
@@ -348,9 +348,9 @@
 	}
 	if (reply->cache_control) {
 	    if (EBIT_TEST(reply->cache_control->mask, CC_PROXY_REVALIDATE))
-		EBIT_SET(entry->flags, ENTRY_REVALIDATE);
+		EBIT_SET(entry->Sflag, ENTRY_REVALIDATE);
 	    else if (EBIT_TEST(reply->cache_control->mask, CC_MUST_REVALIDATE))
-		EBIT_SET(entry->flags, ENTRY_REVALIDATE);
+		EBIT_SET(entry->Sflag, ENTRY_REVALIDATE);
 	}
 	if (httpState->flags.keepalive)
 	    if (httpState->peer)
@@ -456,7 +456,7 @@
     else
 	delay_id = delayMostBytesAllowed(entry->mem_obj);
 #endif
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(fd);
 	return;
     }
@@ -536,11 +536,11 @@
 		 * allow the client to get it.
 		 */
 		if (!fwdReforwardableStatus(s))
-		    EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
+		    EBIT_CLR(entry->Sflag, ENTRY_FWD_HDR_WAIT);
 	    }
 	}
 	storeAppend(entry, buf, len);
-	if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+	if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	    /*
 	     * the above storeAppend() call could ABORT this entry,
 	     * in that case, the server FD should already be closed.
@@ -631,8 +631,8 @@
     HttpHeaderPos pos = HttpHeaderInitPos;
     httpHeaderInit(hdr_out, hoRequest);
     /* append our IMS header */
-    if (entry && entry->lastmod > -1 && request->method == METHOD_GET)
-	httpHeaderPutTime(hdr_out, HDR_IF_MODIFIED_SINCE, entry->lastmod);
+    if (entry && entry->Slastmod > -1 && request->method == METHOD_GET)
+	httpHeaderPutTime(hdr_out, HDR_IF_MODIFIED_SINCE, entry->Slastmod);
 
     /* decide if we want to do Ranges ourselves 
      * (and fetch the whole object now)
@@ -935,7 +935,7 @@
 	comm_close(fd);
 	return;
     }
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_ABORTED)) {
 	comm_close(fd);
 	return;
     }
Index: squid/src/main.c
diff -u squid/src/main.c:1.1.1.2 squid/src/main.c:1.1.1.2.10.1
--- squid/src/main.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/main.c	Fri Nov 10 10:44:52 2000
@@ -516,8 +516,10 @@
     time_t loop_delay;
 
     debug_log = stderr;
+#if !HAVE_POLL
     if (FD_SETSIZE < Squid_MaxFD)
 	Squid_MaxFD = FD_SETSIZE;
+#endif
 
     /* call mallopt() before anything else */
 #if HAVE_MALLOPT
@@ -691,6 +693,7 @@
     if (*(argv[0]) == '(')
 	return;
     openlog(appname, LOG_PID | LOG_NDELAY | LOG_CONS, LOG_LOCAL4);
+    if (getppid() != 1)
     if ((pid = fork()) < 0)
 	syslog(LOG_ALERT, "fork failed: %s", xstrerror());
     else if (pid > 0)
@@ -741,9 +744,12 @@
 	    failcount++;
 	else
 	    failcount = 0;
-	if (failcount == 5) {
-	    syslog(LOG_ALERT, "Exiting due to repeated, frequent failures");
-	    exit(1);
+	if (failcount >= 5) {
+	    extern char **environ;
+	    if (failcount == 5)
+		syslog(LOG_ALERT, "Repeated frequent failures!");
+	    sleep(1);
+	    execve(argv[0], argv, environ);
 	}
 	if (WIFEXITED(status))
 	    if (WEXITSTATUS(status) == 0)
@@ -806,6 +812,7 @@
     if (opt_no_daemon) {
 	file_close(0);
 	file_close(1);
+	if (opt_debug_stderr < 0)
 	file_close(2);
     }
 #endif
Index: squid/src/mem.c
diff -u squid/src/mem.c:1.1.1.2 squid/src/mem.c:1.1.1.2.12.1
--- squid/src/mem.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/mem.c	Fri Nov 10 10:44:52 2000
@@ -280,6 +280,8 @@
     memDataInit(MEM_STMEM_BUF, "Store Mem Buffer", SM_PAGE_SIZE,
 	Config.memMaxSize / SM_PAGE_SIZE);
     memDataInit(MEM_STOREENTRY, "StoreEntry", sizeof(StoreEntry), 0);
+    memDataInit(MEM_STORESWAPLOGDATA, "storeSwapLogData",
+	sizeof(storeSwapLogData), 0);
     memDataInit(MEM_STORE_CLIENT, "store_client", sizeof(store_client), 0);
     memDataInit(MEM_SWAPDIR, "SwapDir", sizeof(SwapDir), 0);
     memDataInit(MEM_USHORTLIST, "ushort_list", sizeof(ushortlist), 0);
Index: squid/src/mime.c
diff -u squid/src/mime.c:1.1.1.2 squid/src/mime.c:1.1.1.2.12.1
--- squid/src/mime.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/mime.c	Fri Nov 10 10:44:52 2000
@@ -431,9 +431,9 @@
     while ((n = read(fd, buf, 4096)) > 0)
 	storeAppend(e, buf, n);
     file_close(fd);
+    EBIT_SET(e->Sflag, ENTRY_SPECIAL);
     storeComplete(e);
     storeTimestampsSet(e);
-    EBIT_SET(e->flags, ENTRY_SPECIAL);
     debug(25, 3) ("Loaded icon %s\n", url);
     storeUnlockObject(e);
     memFree(buf, MEM_4K_BUF);
Index: squid/src/mime.conf
diff -u squid/src/mime.conf:1.1.1.2 squid/src/mime.conf:1.1.1.2.12.1
--- squid/src/mime.conf:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/mime.conf	Fri Nov 10 10:44:52 2000
@@ -30,6 +30,8 @@
 ^internal-unknown$	-			anthony-unknown.gif	-	ascii
 ^internal-view$		-			anthony-text.gif	-	ascii
 ^internal-download$	-			anthony-box.gif		-	ascii
+^internal-closeme$	-			closeme.html		-	ascii
+^internal-tiny$		-			tiny.gif		-	ascii
 \.bin$		application/macbinary		anthony-unknown.gif		-		image
 \.oda$		application/oda			anthony-unknown.gif		-		image
 \.exe$		application/octet-stream	anthony-unknown.gif		-		image
